//+------------------------------------------------------------------+
//|                         Complex Frame Percent Colored Histogram  |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
//----
string Indicator_Name = "CFP_Histogram";
//----
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 DarkGoldenrod
#property indicator_color3 Black

//----
extern int MA_Method = 3;
extern int Price = 6;
extern int Fast = 3;
extern int Slow = 5;
 bool USD = 1;
 bool EUR = 1;
 bool GBP = 1;
 bool CHF = 1;
 bool JPY = 1;
 bool AUD = 1;
 bool CAD = 1;
 bool NZD = 1;
 int Bars.Count = 0;
 color CFP.OutLine.Color = Black;
 int   CFP.OutLine.Width = 1;
 color CFP.Up.Color      = Green;
 int   CFP.Up.Width      = 2;
 color CFP.Dn.Color      = Orange;
 int   CFP.Dn.Width      = 2;

//----
double OUT[];
double OUTUp[];
double OUTDn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName(Indicator_Name + " (" + Symbol() + ", " + Period() + ")");
   
   SetIndexBuffer(0, OUTUp);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, CFP.Up.Width, CFP.Up.Color);
   SetIndexLabel(0, Symbol()); 

   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, CFP.Dn.Width, CFP.Dn.Color);
   SetIndexBuffer(1, OUTDn);
   SetIndexLabel(1, Symbol()); 

   SetIndexBuffer(2, OUT);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, CFP.OutLine.Width, CFP.OutLine.Color);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double arrUSD, arrEUR, arrGBP, arrCHF, arrJPY, arrAUD, arrCAD, arrNZD;
   int limit;
  if (IndicatorCounted()<0) return(-1);
  limit=Bars-IndicatorCounted();
  if (Bars.Count>0 && limit>Bars.Count) limit=Bars.Count;
//----  
   for(int i = 0; i < limit; i++)
     {
       //  
       if(EUR)
         {
           double EURUSD_FX_Fast = ma("EURUSD", Fast, MA_Method, Price, i);
           double EURUSD_FX_Slow = ma("EURUSD", Slow, MA_Method, Price, i);
           if(!EURUSD_FX_Fast || !EURUSD_FX_Slow)
               break;
         }
       if(GBP)
         {
           double GBPUSD_FX_Fast = ma("GBPUSD", Fast, MA_Method, Price, i);
           double GBPUSD_FX_Slow = ma("GBPUSD", Slow, MA_Method, Price, i);
           if(!GBPUSD_FX_Fast || !GBPUSD_FX_Slow)
               break;
         }
       if(AUD)
         {
           double AUDUSD_FX_Fast = ma("AUDUSD", Fast, MA_Method, Price, i);
           double AUDUSD_FX_Slow = ma("AUDUSD", Slow, MA_Method, Price, i);
           if(!AUDUSD_FX_Fast || !AUDUSD_FX_Slow)
               break;
         }
       if(NZD)
         {
           double NZDUSD_FX_Fast = ma("NZDUSD", Fast, MA_Method, Price, i);
           double NZDUSD_FX_Slow=ma("NZDUSD", Slow, MA_Method, Price, i);
           if(!NZDUSD_FX_Fast || !NZDUSD_FX_Slow)
               break;
         }
       if(CAD)
         {
           double USDCAD_FX_Fast = ma("USDCAD", Fast, MA_Method, Price, i);
           double USDCAD_FX_Slow = ma("USDCAD", Slow, MA_Method, Price, i);
           if(!USDCAD_FX_Fast || !USDCAD_FX_Slow)
               break;
         }
       if(CHF)
         {
           double USDCHF_FX_Fast = ma("USDCHF", Fast, MA_Method, Price, i);
           double USDCHF_FX_Slow = ma("USDCHF", Slow, MA_Method, Price, i);
           if(!USDCHF_FX_Fast || !USDCHF_FX_Slow)
               break;
         }
       if(JPY)
         {
           double USDJPY_FX_Fast = ma("USDJPY", Fast, MA_Method, Price, i);
           double USDJPY_FX_Slow = ma("USDJPY", Slow, MA_Method, Price, i);
           if(!USDJPY_FX_Fast || !USDJPY_FX_Slow)
               break;
         }
       //  
       if(USD)
         {
           arrUSD = 0;
           if(EUR) 
               arrUSD += EURUSD_FX_Slow / EURUSD_FX_Fast - 1;
           if(GBP) 
               arrUSD += GBPUSD_FX_Slow / GBPUSD_FX_Fast - 1;
           if(AUD) 
               arrUSD += AUDUSD_FX_Slow / AUDUSD_FX_Fast - 1;
           if(NZD) 
               arrUSD += NZDUSD_FX_Slow / NZDUSD_FX_Fast - 1;
           if(CHF) 
               arrUSD += USDCHF_FX_Fast / USDCHF_FX_Slow - 1;
           if(CAD) 
               arrUSD += USDCAD_FX_Fast / USDCAD_FX_Slow - 1;
           if(JPY) 
               arrUSD += USDJPY_FX_Fast / USDJPY_FX_Slow - 1;
         }// end if USD
       if(EUR)
         {
           arrEUR = 0;
           if(USD) 
               arrEUR += EURUSD_FX_Fast / EURUSD_FX_Slow - 1;
           if(GBP) 
               arrEUR += (EURUSD_FX_Fast / GBPUSD_FX_Fast) / 
                         (EURUSD_FX_Slow / GBPUSD_FX_Slow) - 1;
           if(AUD) 
               arrEUR += (EURUSD_FX_Fast / AUDUSD_FX_Fast) / 
                         (EURUSD_FX_Slow / AUDUSD_FX_Slow) - 1;
           if(NZD) 
               arrEUR += (EURUSD_FX_Fast / NZDUSD_FX_Fast) / 
                         (EURUSD_FX_Slow / NZDUSD_FX_Slow) - 1;
           if(CHF) 
               arrEUR += (EURUSD_FX_Fast*USDCHF_FX_Fast) / 
                         (EURUSD_FX_Slow*USDCHF_FX_Slow) - 1;
           if(CAD) 
               arrEUR += (EURUSD_FX_Fast*USDCAD_FX_Fast) / 
                         (EURUSD_FX_Slow*USDCAD_FX_Slow) - 1;
           if(JPY) 
               arrEUR += (EURUSD_FX_Fast*USDJPY_FX_Fast) / 
                         (EURUSD_FX_Slow*USDJPY_FX_Slow) - 1;
         }// end if EUR
         
       if(GBP)
         {
           arrGBP = 0;
           if(USD) 
               arrGBP += GBPUSD_FX_Fast/GBPUSD_FX_Slow-1;
           if(EUR) 
               arrGBP += (EURUSD_FX_Slow / GBPUSD_FX_Slow) / 
                         (EURUSD_FX_Fast / GBPUSD_FX_Fast) - 1;
           if(AUD) 
               arrGBP += (GBPUSD_FX_Fast / AUDUSD_FX_Fast) / 
                         (GBPUSD_FX_Slow / AUDUSD_FX_Slow) - 1;
           if(NZD) 
               arrGBP += (GBPUSD_FX_Fast / NZDUSD_FX_Fast) / 
                         (GBPUSD_FX_Slow / NZDUSD_FX_Slow) - 1;
           if(CHF) 
               arrGBP += (GBPUSD_FX_Fast*USDCHF_FX_Fast) / 
                         (GBPUSD_FX_Slow*USDCHF_FX_Slow) - 1;
           if(CAD) 
               arrGBP += (GBPUSD_FX_Fast*USDCAD_FX_Fast) / 
                         (GBPUSD_FX_Slow*USDCAD_FX_Slow) - 1;
           if(JPY) 
               arrGBP += (GBPUSD_FX_Fast*USDJPY_FX_Fast) / 
                         (GBPUSD_FX_Slow*USDJPY_FX_Slow) - 1;
         }// end if GBP
       if(AUD)
         {
           arrAUD = 0;
           if(USD) 
               arrAUD += AUDUSD_FX_Fast / AUDUSD_FX_Slow - 1;
           if(EUR) 
               arrAUD += (EURUSD_FX_Slow / AUDUSD_FX_Slow) / 
               (EURUSD_FX_Fast / AUDUSD_FX_Fast) - 1;
           if(GBP) 
               arrAUD += (GBPUSD_FX_Slow / AUDUSD_FX_Slow) / 
               (GBPUSD_FX_Fast / AUDUSD_FX_Fast) - 1;
           if(NZD) 
               arrAUD += (AUDUSD_FX_Fast / NZDUSD_FX_Fast) / 
               (AUDUSD_FX_Slow / NZDUSD_FX_Slow) - 1;
           if(CHF) 
               arrAUD += (AUDUSD_FX_Fast*USDCHF_FX_Fast) / 
               (AUDUSD_FX_Slow*USDCHF_FX_Slow) - 1;
           if(CAD) 
               arrAUD += (AUDUSD_FX_Fast*USDCAD_FX_Fast) / 
               (AUDUSD_FX_Slow*USDCAD_FX_Slow) - 1;
           if(JPY) 
               arrAUD += (AUDUSD_FX_Fast*USDJPY_FX_Fast) / 
               (AUDUSD_FX_Slow*USDJPY_FX_Slow) - 1;
         }// end if AUD
       if(NZD)
         {
           arrNZD = 0;
           if(USD) 
               arrNZD += NZDUSD_FX_Fast / NZDUSD_FX_Slow - 1;
           if(EUR) 
               arrNZD += (EURUSD_FX_Slow / NZDUSD_FX_Slow) / 
                         (EURUSD_FX_Fast / NZDUSD_FX_Fast) - 1;
           if(GBP) 
               arrNZD += (GBPUSD_FX_Slow / NZDUSD_FX_Slow) / 
                         (GBPUSD_FX_Fast / NZDUSD_FX_Fast) - 1;
           if(AUD) 
               arrNZD += (AUDUSD_FX_Slow / NZDUSD_FX_Slow) / 
                         (AUDUSD_FX_Fast / NZDUSD_FX_Fast) - 1;
           if(CHF) 
               arrNZD += (NZDUSD_FX_Fast*USDCHF_FX_Fast) / 
                         (NZDUSD_FX_Slow*USDCHF_FX_Slow) - 1;
           if(CAD) 
               arrNZD += (NZDUSD_FX_Fast*USDCAD_FX_Fast) / 
                         (NZDUSD_FX_Slow*USDCAD_FX_Slow) - 1;
           if(JPY) 
               arrNZD += (NZDUSD_FX_Fast*USDJPY_FX_Fast) / 
                         (NZDUSD_FX_Slow*USDJPY_FX_Slow) - 1;
         }// end if NZD
       if(CAD)
         {
           arrCAD = 0;
           if(USD) 
               arrCAD += USDCAD_FX_Slow / USDCAD_FX_Fast - 1;
           if(EUR) 
               arrCAD += (EURUSD_FX_Slow*USDCAD_FX_Slow) / 
                         (EURUSD_FX_Fast*USDCAD_FX_Fast) - 1;
           if(GBP) 
               arrCAD += (GBPUSD_FX_Slow*USDCAD_FX_Slow) / 
                         (GBPUSD_FX_Fast*USDCAD_FX_Fast) - 1;
           if(AUD) 
               arrCAD += (AUDUSD_FX_Slow*USDCAD_FX_Slow) / 
                         (AUDUSD_FX_Fast*USDCAD_FX_Fast) - 1;
           if(NZD) 
               arrCAD += (NZDUSD_FX_Slow*USDCAD_FX_Slow) / 
                         (NZDUSD_FX_Fast*USDCAD_FX_Fast) - 1;
           if(CHF) 
               arrCAD += (USDCHF_FX_Fast / USDCAD_FX_Fast) / 
                         (USDCHF_FX_Slow/USDCAD_FX_Slow) - 1;
           if(JPY) 
               arrCAD += (USDJPY_FX_Fast / USDCAD_FX_Fast) / 
                         (USDJPY_FX_Slow/USDCAD_FX_Slow) - 1;
         }// end if CAD
       if(CHF)
         {
           arrCHF = 0;
           if(USD) 
               arrCHF += USDCHF_FX_Slow / USDCHF_FX_Fast - 1;
           if(EUR) 
               arrCHF += (EURUSD_FX_Slow*USDCHF_FX_Slow) / 
                         (EURUSD_FX_Fast*USDCHF_FX_Fast) - 1;
           if(GBP) 
               arrCHF += (GBPUSD_FX_Slow*USDCHF_FX_Slow) / 
                         (GBPUSD_FX_Fast*USDCHF_FX_Fast) - 1;
           if(AUD) 
               arrCHF += (AUDUSD_FX_Slow*USDCHF_FX_Slow) / 
                         (AUDUSD_FX_Fast*USDCHF_FX_Fast) - 1;
           if(NZD) 
               arrCHF += (NZDUSD_FX_Slow*USDCHF_FX_Slow) / 
                         (NZDUSD_FX_Fast*USDCHF_FX_Fast) - 1;
           if(CAD) 
               arrCHF += (USDCHF_FX_Slow/USDCAD_FX_Slow) / 
                         (USDCHF_FX_Fast/USDCAD_FX_Fast) - 1;
           if(JPY) 
               arrCHF += (USDJPY_FX_Fast/USDCHF_FX_Fast) / 
                         (USDJPY_FX_Slow/USDCHF_FX_Slow) - 1;
         }// end if CHF
       if(JPY)
         {
           arrJPY = 0;
           if(USD) 
               arrJPY += USDJPY_FX_Slow / USDJPY_FX_Fast - 1;
           if(EUR) 
               arrJPY += (EURUSD_FX_Slow*USDJPY_FX_Slow) / 
                         (EURUSD_FX_Fast*USDJPY_FX_Fast) - 1;
           if(GBP) 
               arrJPY += (GBPUSD_FX_Slow*USDJPY_FX_Slow) / 
                         (GBPUSD_FX_Fast*USDJPY_FX_Fast) - 1;
           if(AUD) 
               arrJPY += (AUDUSD_FX_Slow*USDJPY_FX_Slow) / 
                         (AUDUSD_FX_Fast*USDJPY_FX_Fast) - 1;
           if(NZD) 
               arrJPY += (NZDUSD_FX_Slow*USDJPY_FX_Slow) / 
                         (NZDUSD_FX_Fast*USDJPY_FX_Fast) - 1;
           if(CAD) 
               arrJPY += (USDJPY_FX_Slow / USDCAD_FX_Slow) / 
                         (USDJPY_FX_Fast / USDCAD_FX_Fast) - 1;
           if(CHF) 
               arrJPY += (USDJPY_FX_Slow / USDCHF_FX_Slow) / 
                         (USDJPY_FX_Fast / USDCHF_FX_Fast) - 1;
         }// end if JPY

       OUT[i] = 0;
       if(0 == StringFind(Symbol(), "USD", 0))
           OUT[i] += arrUSD;
       if(3 == StringFind(Symbol(), "USD", 0))
           OUT[i] -= arrUSD;
       if(0 == StringFind(Symbol(), "EUR", 0))
           OUT[i] += arrEUR;
       if(0 == StringFind(Symbol(), "GBP", 0))
           OUT[i] += arrGBP;
       if(3 == StringFind(Symbol(), "GBP", 0))
           OUT[i] -= arrGBP;
       if(0 == StringFind(Symbol(), "CHF", 0))
           OUT[i] += arrCHF;
       if(3 == StringFind(Symbol(), "CHF", 0))
           OUT[i] -= arrCHF;
       if(3 == StringFind(Symbol(), "JPY", 0))
           OUT[i] -= arrJPY;
       if(0 == StringFind(Symbol(), "CAD", 0))
           OUT[i] += arrCAD;
       if(3 == StringFind(Symbol(), "CAD", 0))
           OUT[i] -= arrCAD;
       if(0 == StringFind(Symbol(), "AUD", 0))
           OUT[i] += arrAUD;
       if(3 == StringFind(Symbol(), "AUD", 0))
           OUT[i] -= arrAUD;
       if(0 == StringFind(Symbol(), "NZD", 0))
           OUT[i] += arrNZD;
       if(3 == StringFind(Symbol(), "NZD", 0))
           OUT[i] -= arrNZD;

       if (OUT[i] > 0)
         {
             OUTUp[i] = OUT[i];
             OUTDn[i] = 0.0;
         }
       else 
         {
             OUTDn[i] = OUT[i];
             OUTUp[i] = 0.0;
         }      

     }//end block for(int i=0; i<limit; i++)
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|  Subroutine                                                      |
//+------------------------------------------------------------------+
double ma(string sym, int per, int Mode, int Price, int i)
  {
   double res = 0;
   int k = 1;
   int ma_shift = 0;
   int tf = 0;
   switch(Period())
     {
       case 1:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 5;
       case 5:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 3;
       case 15:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 2;
       case 30:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 2;
       case 60:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 3;//4
       case 240:   res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 6;
       case 1440:  res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 4;
       case 10080: res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
                   k += 4;
       case 43200: res += iMA(sym, tf, per*k, ma_shift, Mode, Price,i); 
     }
   return(res);
  }   
//+------------------------------------------------------------------+


